(function(){
	API.url = 'http://server2.linko.mx:8181/Yapp/'; // trailing slash required
	API.key = 'd72cd1e68872460b51b24d54ad3a56c8';

	/**
	 * Simple validation  for API calls
	 * Expects:
	 * object = {
	 *		type : (string) 'POST' || 'GET' || 'DELETE',
	 *      url  : (string) No special chars,
	 *		data : (object) optional, will be converted to urlsafe.
	 * }
	 * function  callback (status)
	 *
	 * Note: 'this' will contain the raw xhr response and the parsed response object.
	 */
	API.call = function(obj){
		if (typeof obj != 'object')            return alert('[API] invalid object.');
		if (typeof obj.callback != 'function') return alert('[API] invalid callback.');
		// type's string; Enforce uppercase 'n make sure we get correct transfer type
		if (
			typeof obj.type != 'string'
		||	(
				(obj.type = obj.type.toUpperCase())
			&&	(obj.type != 'POST' && obj.type != 'GET' && obj.type != 'DELETE')
		)) return alert('[API] invalid type.');
		// url's string; must only contain a-z
		if (typeof obj.url != 'string' )
			return alert('[API] invaid URL');
		// Data is optional
		if (typeof obj.data != 'object') obj.data = '';
		else{
			var key, data = '';
			for (key in obj.data)
				data += (data.length? '&' : '') + key + '=' + obj.data[key];
			obj.data = data;
		};
		// setup connection
		var xhr  = Ti.Network.createHTTPClient();
		var desc = '[XHR] '+ obj.url.toUpperCase() + ' ' + obj.type;

		// show info messages if debug enabled
		xhr.onload = function(){
			if (__DEBUG !== true) return false;
			Ti.API.info(desc + ' LOAD ' + this.responseText);
		};

		xhr.onerror = function(){
			if (__DEBUG === true) Ti.API.info(desc + ' ERROR ' + this.status);
			obj.callback.call(this, false);
		};

		xhr.onreadystatechange = function(){
			if (__DEBUG === true) Ti.API.info(desc + ' STATE:' + this.readyState);
			if (this.readyState !== 4) return false;
			// parse custom server response
			var result   = {};
			var response = JSON.parse(this.responseText).response;
			for (i in response) {
				if (typeof response[i] != 'object') continue;
				for (name in response[i]) break;
				if (typeof response[i][name] != 'object')
					result[name] = response[i][name];
				else {
					result[name] = {};
					for (j in response[i][name]) {
						for (surname in response[i][name][j]) break;
						result[name][surname] = response[i][name][j][surname];
					}
				}
			}
			response = { raw:this, object:result }
			obj.callback.call(response, true);
		};

		var url = API.url + obj.url;
		var uri = (obj.data.length? obj.data : '');

		if (__DEBUG === true){
			Ti.API.info('Opening: ' + url);
			Ti.API.info('Sending: ' + uri);
		}

		xhr.open(obj.type, url);
		xhr.send(uri);
	}
})();