var __DEBUG   = true;
var __VERSION = '1.0';
// how much time to wait before attempting to contact the server after an error.
var __TIMEOUT = 3000;

var path = Ti.Filesystem.resourcesDirectory;
var API        = {}; // api.js
var QR         = {};
var loader     = {}; // loader.js
var spinner    = {};
var header     = {};
var config     = {}; // config.js
var splash     = {}; // splash.js
var signup     = {};
var login      = {}; // login.js
var main       = {};
var items      = {};
var pedidos    = {};
var database   = {};
var help       = {};
var add2cart   = {};
var order      = {};
var giveittome = {};
var setup      = {};
var cardsui    = {};
var addressui  = {};
var invoiceui  = {};
var model	   = {};

var response   = null; // Server's last response
var error      = null;
var dbReady    = null;
var userId     = null;

// Initialize Helper modules
Ti.include('error.js');
Ti.include('loader.js');
Ti.include('api.js');
Ti.include('spinner.js');
Ti.include('header.js');
Ti.include('model.js');

/**
 * Sets up connection with server and initializes database.
**/
var init = function(){
	// Setup database
	if (typeof database.xmas == 'undefined') Ti.include('database.js');
	dbReady = database.xmas.openDatabase();
	// wait until configuration is fetched from server and then call splash()
	if (typeof config.xmas == 'undefined') Ti.include('config.js');
}

var splash = function(){
	if (typeof splash.xmas == 'undefined') Ti.include('splash.js');
	splash.xmas.createWindow();
}

var authSignup = function(){
	//if (database.xmas.isRegistered()) {
	if (typeof signup.xmas == 'undefined') Ti.include('signup.js');
	signup.xmas.createWindow();
}

var authLogin = function(){
	if (typeof login.xmas == 'undefined') Ti.include('login.js');
	login.xmas.createWindow();
}

var yapp = function(){
	if (typeof main.xmas == 'undefined') Ti.include('main.js');
	if (typeof QR.xmas == 'undefined') Ti.include('qr.js');
	main.xmas.createWindow();
}

var yappSetup = function(){
	if (typeof setup.xmas == 'undefined') {
		Ti.include('setup.js');
		Ti.include('cardsUI.js');
		Ti.include('addressUI.js');
		Ti.include('invoiceUI.js');
	}
	setup.xmas.createWindow();
}

var yappHelp = function(){
	if (typeof help.xmas == 'undefined') Ti.include('help.js');
	help.xmas.createWindow();
}

var yappPedidos = function(){
	if (typeof pedidos.xmas == 'undefined'){
		Ti.include('order.js');
		Ti.include('pedidos.js');
	}
	pedidos.xmas.createWindow();
}

var yappItems = function(item){
	if (typeof items.xmas == 'undefined') Ti.include('items.js');
	items.xmas.createWindow(item);
}

init();

//Ti.include('signup.js');
//signup.xmas.step3.createWindow();

//Ti.include('qr.js');
//QR.xmas.capture();



