(function(){

	login.xmas = {
		window       : null,
		viewHeader   : null,
		viewContent  : null,
		labelUser    : null,
		fieldUser    : null,
		labelPass    : null,
		fieldPass    : null,
		buttonSubmit : null
	};

	/**
	 * Main Login Window
	 */
	login.xmas.createWindow = function(){
		// ---------------------------------------------------- Common variables
		var
			vTop        = 0,
			vLeft       = 20,
			vWidth      = 280,
			vHeight     = 31,
			vPadBottom  = 10,
			vColorLight = '#fff',
			vColorDark  = '#222',
			vColorBG    = 'transparent',
			vFontNormal = { fontSize:16 },
			vFontBold   = { fontSize:16, fontWeight:'bold' };

		// Calculate relative padding
		var padBottom = function(doublePad){
			doublePad = (typeof doublePad != 'undefined');
			return vTop += vHeight + (doublePad? vPadBottom : 0);
		}

		// -------------------------------------------------------------- Window

		login.xmas.window = Ti.UI.createWindow({
			title           : 'Login',
			id              : 'Login',
			backgroundImage : '/images/back.png'
		});

		// --------------------------------------------------------------- Views

		login.xmas.header = header.xmas.get({
			labelLeft: 'Atrás'
		});

		login.xmas.content = Ti.UI.createView({
			top             : 112, // manually calculated centering position
			left            : 0,
			width           : 320,
			height          : 'auto',
			backgroundColor : vColorBG
		});

		// ---------------------------------------------------------------- User

		login.xmas.labelUser = Ti.UI.createLabel({
			text      : 'Usuario:',
			top       : vTop,
			left      : vLeft,
			width     : vWidth,
			height    : vHeight,
			font      : vFontNormal,
			color     : vColorLight,
			textAlign : 'left'
		});

		login.xmas.fieldUser = Ti.UI.createTextField({
			value           : null,
			top             : padBottom(),
			left            : vLeft,
			width           : vWidth,
			height          : vHeight,
			font            : vFontBold,
			color           : vColorDark,
			backgroundColor : vColorBG,
			borderStyle     : Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
			returnKeyType   : Titanium.UI.RETURNKEY_NEXT,
		});

		// ------------------------------------------------------------ Password

		login.xmas.labelPass = Ti.UI.createLabel({
			text      : 'Contraseña:',
			top       : padBottom(true),
			left      : vLeft,
			width     : vWidth,
			height    : vHeight,
			font      : vFontNormal,
			color     : vColorLight,
			textAlign : 'left'
		});

		login.xmas.fieldPass = Ti.UI.createTextField({
			value           : null,
			top             : padBottom(),
			left            : vLeft,
			width           : vWidth,
			height          : vHeight,
			font            : vFontBold,
			color           : vColorDark,
			backgroundColor : vColorBG,
			passwordMask    : true,
			borderStyle     : Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
			returnKeyType   : Titanium.UI.RETURNKEY_DONE,
		});

		// -------------------------------------------------------------- Submit

		login.xmas.buttonSubmit = Ti.UI.createButton({
 			title  : 'ACCESO',
			top    : 283,
			width  : 119,
			height : 43,
			color  : '#FFF',
			backgroundImage:'/images/button.png',
			font:{
				fontSize:13.5,
				fontWeight:'bold'
			}
		});

		// -------------------------------------------------------------- Events

		login.xmas.buttonSubmit.addEventListener('click', login.xmas.verifyCredentials);

		login.xmas.header.buttonLeft.addEventListener('click', function(){
			splash();
			login.xmas.window.close();
		});

		// ---------------------------------------------------------- Assambling

		login.xmas.content.add(login.xmas.labelUser);
		login.xmas.content.add(login.xmas.fieldUser);
		login.xmas.content.add(login.xmas.labelPass);
		login.xmas.content.add(login.xmas.fieldPass);
		login.xmas.content.add(login.xmas.buttonSubmit);

		login.xmas.window.add(login.xmas.header.view);
		login.xmas.window.add(login.xmas.content);

		login.xmas.window.open();
	};

	/**
	 * Clean out login fields so users can retry their logins.
	 */
	login.xmas.resetForm = function(){
		alert('Credenciales Inválidas');
		login.xmas.fieldUser.value = null;
		login.xmas.fieldPass.value = null;
	};

	/**
	 * User clicks login button.
	 */
	login.xmas.verifyCredentials = function(e){
		// no need to make a call  to the server if no data is available.
		if (
			typeof login.xmas.fieldUser != 'object'
		||	!login.xmas.fieldUser.value
		||	typeof login.xmas.fieldPass != 'object'
		||  !login.xmas.fieldPass.value
		)  return login.xmas.resetForm();
		// Data available, while checking credentials show  loader
		loader.xmas.show();
		API.call({
			type : 'post',
			url  : 'login',
			data : {
				uname : login.xmas.fieldUser.value.toString(),
				pwd   : login.xmas.fieldPass.value.toString(),
				appVersion: __VERSION
			},
			callback : function(success){
				loader.xmas.hide();
				if (!success || this.raw.status == 400) return login.xmas.resetForm();
				else if (this.raw.status != 200)
					return error('Respuesta del servidor inválida [' + this.raw.status + ']');
				//response =  JSON.parse(this.responseText).response;
				response = eval('('+this.raw.responseText+')').response;
				user = response[2].user[0].id;
				login.xmas.window.close();
				yapp();
			}
		})
	};
})();
